{% extends "ajax/soul/shell.html.twig" %}
{% block title %}{{'Einstellungen'|trans({}, 'game')}}{% endblock %}
{% block soul_content %}
    <div class="row">

        {% if et_ready and app.user.eternalID is null %}
            <div class="cell rw-12 padded">
                <h5>{{ 'Über EternalTwin einloggen'|trans({},'login') }}</h5>
                <div class="eternalMergeBanner">
                    <div class="row">
                        <div class="cell rw-2 padded">
                            <img class="fit" alt="" src="{{ asset('build/images/eternal-twin/icon_large.png') }}">
                        </div>
                        <div class="cell rw-10 padded">
                            <strong>{{ 'MyHordes ist ein stolzer Bestandteil des EternalTwin-Netzwerkes!'|trans({},'soul') }}</strong>
                            {{ 'Um MyHordes auch in Zukunft weiter spielen zu können, musst du deinen alten MyHordes-Account mit einem EternalTwin-Account verknüpfen.'|trans({},'soul') }}
                            {{ 'Deine Seele bleibt bei der Verknüpfung mit EternalTwin selbstverständlich vollständig erhalten.'|trans({},'login') }}
                            <br />
                            <a class="button" target="_self" href="{{ url('gateway-etwin') }}">{{ 'EternalTwin-Account verknüpfen'|trans({},'soul') }}</a>
                        </div>
                    </div>
                </div>
            </div>
        {% endif %}

        {% if not app.user.tosAccepted or not app.user.tosUpdateAccepted %}
            <div class="cell rw-12 padded">
                <div class="note critical">
                    {{ 'Du hast den Nutzungsbedingungen von MyHordes noch nicht zugestimmt. Beachte, dass du diese Warnung nicht für immer ignorieren kannst.'|trans({},'login') }}
                    <a href="#" x-ajax-href="{{ url('public_accept_tos') }}">{{ 'Zum Zustimmungsdialog wechseln'|trans({},'login') }}</a>
                </div>
            </div>
        {% endif %}

        <div class="cell rw-12 padded">
            <div class="tab-floater">
                <ul class="tabs plain" x-tab-group="user-settings-tabs" x-tab-control>
                    <li class="tab" x-tab-id="profile"><div class="tab-link">
                        <img alt="" src="{{ asset('build/images/icons/small_user.gif') }}" />
                        <span class="hide-md hide-sm">{{ 'Profil und Avatar'|trans({},'soul') }}</span>
                    </div></li>
                    <li class="tab" x-tab-id="security"><div class="tab-link">
                        <img alt="" src="{{ asset('build/images/icons/lock.gif') }}" />
                        <span class="hide-md hide-sm">{{ 'Account und Sicherheit'|trans({},'soul') }}</span>
                    </div></li>
                    {% if show_importer %}
                        <li class="tab" x-tab-id="soul-import"><div class="tab-link">
                            <img alt="" src="{{ asset('build/images/icons/small_ghost_red.gif') }}" />
                            <span class="hide-md hide-sm">{{ 'Seelenimport'|trans({},'soul') }}</span>
                        </div></li>
                    {% endif %}
                    <li class="tab" x-tab-id="general-settings"><div class="tab-link">
                            <img alt="" src="{{ asset('build/images/icons/title/r_repair.gif') }}" />
                            <span class="hide-md hide-sm">{{ 'Allgemein'|trans({},'soul') }}</span>
                        </div></li>
                    <li class="tab" x-tab-id="browser-settings"><div class="tab-link">
                            <img alt="" src="{{ asset('build/images/building/small_eden.gif') }}" />
                            <span class="hide-md hide-sm">{{ 'Browser'|trans({},'soul') }}</span>
                        </div></li>
                    <li class="tab" x-tab-id="expert-settings"><div class="tab-link">
                        <img alt="" src="{{ asset('build/images/icons/small_archive.gif') }}" />
                        <span class="hide-md hide-sm">{{ 'Erweitert'|trans({},'soul') }}</span>
                    </div></li>
                </ul>
            </div>
        </div>

        <div class="cell rw-12 padded">

            <div x-tab-target x-tab-group="user-settings-tabs" x-tab-id="profile">
                <h5>{{ 'Dein Profil'|trans({},'soul') }}</h5>
                <div class="row">
                    <div class="padded cell rw-3 rw-md-4 rw-sm-12">
                        <div class="note note-lightest">
                            <label for="user_displayname">{{ 'Dein Spielername'|trans({}, 'soul') }}</label>
                        </div>
                    </div>
                    <div class="padded cell rw-9 rw-md-8 rw-sm-12">
                        <input {% if app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionProfileDisplayName')) or (app.user.eternalID is not null and not app.user.noAutomaticNameManagement) or next_name_change_days > 0 %}disabled{% endif %} id="user_displayname" type="text" value="{% if app.user.displayName is not null %}{{ app.user.displayName }}{% else %}{{ app.user.name }}{% endif %}" />
                    </div>
                    {% if (app.user.eternalID is null or app.user.noAutomaticNameManagement) and app.user.displayName is not null and app.user.displayName != app.user.username %}
                        <div class="padded cell ro-3 rw-9 ro-md-4 rw-md-8 ro-sm-0 rw-sm-12">
                            <div  class="note warning-box">
                                {{ 'Um dich einzuloggen, musst du nach wie vor deinen <b>ursprünglichen Namen</b> verwenden: <i>{name}</i>.'|trans({name: app.user.username},'login')|raw }}
                            </div>
                        </div>
                    {% endif %}
                    {% if not app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionProfileDisplayName')) and app.user.eternalID is null and next_name_change_days > 0 %}
                        <div class="padded cell rw-9 ro-3 rw-md-8 ro-md-4 rw-sm-12 ro-sm-0 small">{{ 'Du kannst deinen Spielernamen erst in {days} Tagen erneut ändern.'|trans({days: next_name_change_days}, 'soul') }}</div>
                    {% endif %}
                    <div id="name-warning-box" class="padded cell ro-3 rw-9 ro-md-4 rw-md-8 ro-sm-0 rw-sm-12 {% if app.user.eternalID is null %}hidden{% endif %}">
                        <div  class="note warning-box">
                            {% if app.user.eternalID is null or app.user.noAutomaticNameManagement %}
                                {{ 'WARNUNG: Du kannst deinen Spielernamen nicht jederzeit ändern, wähle ihn also weiße, denn du wirst ihn für mehrere Monate behalten. Um anderen Spielern zu helfen dich zu finden wird der Verlauf deiner Spielernamen in deinem Profil angezeigt.'|trans({}, 'soul') }}
                            {% else %}
                                {{ 'Du kannst deinen Spielernamen nicht ändern, weil du einen zugehörigen Eternal Twin Account hast. Du musst zu deinem Eternal Twin-Konto gehen, um deinen Spielernamen zu ändern.'|trans({}, 'soul') }}<br/><br/>
                                {{ 'Achtung: Die maximale Länge eines Spielernamens auf MyHordes beträgt 16 Zeichen. Wenn du auf Eternaltwin einen längeren Namen wählst, kannst du diesen nicht auf MyHordes übertragen.'|trans({}, 'soul') }}
                            {% endif %}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="padded cell rw-3 rw-md-4 rw-sm-12">
                        <div class="note note-lightest">
                            <label>
                                {{ 'Bevorzugte Pronomen'|trans({}, 'global') }}
                                <a class="help-button"><div class="tooltip help">{{ 'Hier kannst du festlegen, welche Personalpronomen das Spiel verwenden soll, wenn es sich auf dich bezieht (z.B. "männlich" für "er", "ihn", etc und "weiblich" für "sie", "ihr", etc).<br /><em>Diese Einstellung beeinflusst, wie dir und anderen Spielern bestimmte Texte angezeigt werden, wenn die Option "Neue Übersetzungen verwenden" aktiv ist.</em>.'|trans({},'global')|raw }}</div>{{ 'Hilfe'|trans({},'global') }}</a>
                            </label>
                        </div>
                    </div>
                    <div class="cell rw-9 rw-md-8 rw-sm-12">
                        <div class="row-flex wrap">
                            <div class="padded cell"><label class="small"><input {{ app.user.preferredPronoun == constant('App\\Entity\\User::PRONOUN_MALE') ? 'checked' : '' }} type="radio" name="user_pronoun" value="male" /> {{ 'Männlich'|trans({},'global') }}</label></div>
                            <div class="padded cell"><label class="small"><input {{ app.user.preferredPronoun == constant('App\\Entity\\User::PRONOUN_FEMALE') ? 'checked' : '' }} type="radio" name="user_pronoun" value="female" /> {{ 'Weiblich'|trans({},'global') }}</label></div>
                            <div class="padded cell"><label class="small"><input {{ app.user.preferredPronoun is null or app.user.preferredPronoun == constant('App\\Entity\\User::PRONOUN_NONE') ? 'checked' : '' }} type="radio" name="user_pronoun" value="none" /> {{ 'Keine Präferenz'|trans({},'global') }}</label></div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="padded cell rw-3 rw-md-4 rw-sm-12">
                        <div class="note note-lightest">
                            <label>{{ 'Dein Icon'|trans({}, 'global') }}</label>
                        </div>
                    </div>
                    <div class="padded cell rw-9 rw-md-8 rw-sm-12">
                        <input  id="user_icon" type="hidden" value="{% if app.user.activeIcon is null %}-1{% else %}{{ app.user.activeIcon.id }}{% endif %}">
                        {% if app.user.activeIcon is not null %}
                            {% if app.user.activeIcon.prototype %}
                                <img id="user_current_icon" alt="" src="{{ asset('build/images/icons/title/' ~ app.user.activeIcon.prototype.icon ~ '.gif') }}" />
                            {% elseif app.user.activeIcon.customIcon is not null %}
                                <img id="user_current_icon" alt="" src="{{ url('app_web_customicon', {uid: app.user.id, aid: app.user.activeIcon.id, name: app.user.activeIcon.customIconName, ext: app.user.activeIcon.customIconFormat}) }}" />
                            {% endif %}
                        {% else %}
                            <img id="user_current_icon" alt="" src="" style="display: none" />
                        {% endif %}
                        <span id="show_icon_sel" class="pointer small"><img alt="" src="{{ asset('build/images/forum/edit.png') }}"><div class="tooltip help">{{ 'Auswählen'|trans({},'global')|raw }}</div></span>
                        <div id="icon_sel" style="display: none">
                            {% set has_icon = false %}
                            {% for award in app.user.awards %}
                                {% if award.prototype is not null and award.prototype.icon is not null %}
                                    {% set has_icon = true %}
                                    <img {% if app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionProfileTitle')) and app.user.activeIcon != award %}disabled{% endif %} class="pointer" x-title-icon="{{ award.id }}" alt="" src="{{ asset('build/images/icons/title/' ~ award.prototype.icon ~ '.gif') }}" />
                                {% elseif award.customIcon is not null %}
                                    {% set has_icon = true %}
                                    <img {% if app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionProfileTitle')) and app.user.activeIcon != award %}disabled{% endif %} class="pointer" x-title-icon="{{ award.id }}" alt="" src="{{ url('app_web_customicon', {uid: app.user.id, aid: award.id, name: award.customIconName, ext: award.customIconFormat}) }}" />
                                {% endif %}

                            {% endfor %}
                            {% if has_icon %}
                                <span x-title-icon="-1" class="small pointer">[{{ 'Kein Icon'|trans({},'soul') }}]</span>
                            {% else %}<span class="small bold">{{ 'Du hast noch kein Icon freigeschaltet!'|trans({},'soul') }}</span>{% endif %}
                            <br /><span id="hide_icon_sel" class="pointer small"><img alt="" src="{{ asset('build/images/icons/small_remove.gif') }}"><div class="tooltip help">{{ 'Abbrechen'|trans({},'global')|raw }}</div></span>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="padded cell rw-3 rw-md-4 rw-sm-12">
                        <div class="note note-lightest">
                            <label>{{ 'Deine Flagge'|trans({}, 'soul') }}</label>
                        </div>
                    </div>
                    <div class="padded cell rw-9 rw-md-8 rw-sm-12">
                        <div class="row-flex v-center">
                            <input  id="user_flag" type="hidden" value="{% if app.user.flag is null %}{% else %}{{ app.user.flag }}{% endif %}">
                            {% if app.user.flag is not null %}
                                <div class="user-flag" id="user_current_flag"><img alt="{{ app.user.flag }}" src="{{ asset('build/images/lang/any/' ~ app.user.flag ~ '.svg' ) }}"/></div>
                            {% else %}
                                <div class="user-flag hidden" id="user_current_flag"><img alt="" src=""/></div>
                            {% endif %}
                            <span id="show_flag_sel" class="pointer small"><img alt="" src="{{ asset('build/images/forum/edit.png') }}"><div class="tooltip help">{{ 'Auswählen'|trans({},'global')|raw }}</div></span>
                        </div>
                        <div id="flag_sel" class="row-flex wrap v-center gap-small space" style="display: none; margin-top: 5px;">
                            {% for flag in flags %}
                                <div class="user-flag cell pointer" id="user_current_flag" data-flag="{{ flag }}"><img alt="{{ flag }}" src="{{ asset('build/images/lang/any/' ~ flag ~ '.svg' ) }}"/></div>
                            {% endfor %}
                            <span data-flag="" class="small pointer">[{{ 'Spracheinstellung verwenden'|trans({},'soul') }}]</span>
                            <br /><span id="hide_flag_sel" class="pointer small"><img alt="" src="{{ asset('build/images/icons/small_remove.gif') }}"><div class="tooltip help">{{ 'Abbrechen'|trans({},'global')|raw }}</div></span>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="padded cell rw-3 rw-md-4 rw-sm-12">
                        <div class="note note-lightest">
                            <label for="user_title">{{ 'Dein Titel'|trans({}, 'global') }}</label>
                        </div>
                    </div>
                    <div class="padded cell rw-9 rw-md-8 rw-sm-12">
                        <select id="user_title">
                            <option {% if app.user.activeTitle is null %}selected{% endif %} value="-1">--- {{ 'Kein Titel'|trans({},'soul') }} ---</option>
                            {% for id,list in app.user.awards.values|group_titles %}

                                {% set has_title = false %}
                                {% for award in list %}
                                    {% if award.customTitle is not null or (award.prototype is not null and award.prototype.title is not null) %}
                                        {% set has_title = true %}
                                    {% endif %}
                                {% endfor %}

                                {% if has_title %}
                                    <optgroup
                                            {% if id == 'custom' %}
                                                label="{{ 'Einzigartige Errungenschaften'|trans({},'game') }}"
                                            {% elseif id == 'single' %}
                                                label="{{ 'Besondere Errungenschaften'|trans({},'game') }}"
                                            {% else %}
                                                label="{{ list[0].prototype.associatedPicto.label|trans({}, 'game')|raw|trim }}"
                                            {% endif %}
                                    >
                                        {% for award in list %}
                                            {% if award.customTitle is not null %}
                                                <option {% if app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionProfileTitle')) and app.user.activeTitle != award %}disabled{% endif %} {% if app.user.activeTitle == award %}selected{% endif %} value="{{ award.id }}">{{ award.customTitle }}</option>
                                            {% elseif award.prototype is not null and award.prototype.title is not null %}
                                                <option {% if app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionProfileTitle')) and app.user.activeTitle != award %}disabled{% endif %} {% if app.user.activeTitle == award %}selected{% endif %} value="{{ award.id }}">{{ award.prototype.title|trans({},'game')|raw }}</option>
                                            {% endif %}
                                        {% endfor %}
                                    </optgroup>
                                {% endif %}

                            {% endfor %}
                        </select>
                    </div>
                </div>
                <div class="row">
                    <div class="padded cell rw-3 rw-md-4 rw-sm-12">
                        <div class="note note-lightest">
                            <label for="user_desc">{{ 'Deine Beschreibung'|trans({}, 'global') }}</label>
                        </div>
                    </div>
                    <div class="padded cell rw-9 rw-md-8 rw-sm-12">
                        <textarea id="user_desc" style="min-height: 100px;"></textarea>
                    </div>
                </div>
                <div class="row">
                    <div class="padded cell ro-3 rw-9 ro-md-4 rw-md-8 ro-sm-0 rw-sm-12">
                        <button id="save_profile_header">{{ 'Speichern'|trans({},'global') }}</button>
                    </div>
                </div>

                <h5>
                    {{ 'Dein Avatar'|trans({},'soul') }}
                    {{ help_btn(
                        'Die maximale Größe der Bilddatei, die du für deinen Avatar hochladen kannst, beträgt <b>{size}</b>.'|trans({size: avatar_max_size[0]},'soul') ~ '<br />' ~
                        'Nach dem Upload wird der Server dein Bild möglicherweise komprimieren (z.B. indem die Größe reduziert oder Animationsframe optimiert werden).'|trans({},'soul') ~ '<br />' ~
                        'Der Server muss in der Lage sein, dein Bild auf höchstens <b>{size}</b> zu komprimieren - andernfalls kann es nicht gespeichert werden.'|trans({size: avatar_max_size[1]},'soul')  ~ '<br /><br />' ~
                        'Die folgenden Bildformate werden unterstützt:'|trans({},'soul') ~ ' <b>JPEG</b>, <b>GIF</b>, <b>BMP</b>, <b>PNG</b>, ' ~ '<b>WEBP (' ~ 'nur Baseline-Format'|trans({},'soul') ~ ')</b>'
                    ) }}
                </h5>
                <div class="row">
                    <div class="padded cell rw-3 rw-md-4 rw-sm-12">
                        <div class="note note-lightest">
                            <label for="user_title">{{ 'Avatar'|trans({}, 'global') }}</label>
                        </div>
                    </div>
                    <div class="padded cell rw-9 rw-md-8 rw-sm-12">
                        <div class="row">
                            <div class="padded cell rw-3 rw-lg-4 rw-md-12">
                                {% if app.user.avatar is not null %}
                                    <div class="center">
                                        {% if not app.user.avatar.classic %}
                                            <span class="small">{{ 'Normale Anzeige'|trans({},'soul') }}</span><br />
                                        {% endif %}
                                        {% include "ajax/soul/playeravatar.html.twig" with {user: app.user, no_distortion: true} only %}
                                    </div>
                                {% else %}
                                    <div class="help">
                                        {{ 'Damit andere Spieler dich besser erkennen, kannst du hier ein Profilbild hochladen'|trans({},'soul') }}
                                    </div>
                                {% endif %}
                            </div>
                            <div class="padded cell rw-9 rw-lg-8 rw-md-12">
                                {% if app.user.avatar is not null and not app.user.avatar.classic %}
                                    <div class="hide-md hide-sm">
                                        <span class="small">{{ 'Komprimierte Anzeige'|trans({},'soul') }}</span><br />
                                        {% include "ajax/soul/playeravatar.html.twig" with {user: app.user, small: true, no_distortion: true} only %}
                                    </div>
                                    <div class="hide-desktop hide-lg center">
                                        <span class="small">{{ 'Komprimierte Anzeige'|trans({},'soul') }}</span><br />
                                        <div class="avatar small no-arma">
                                            <img alt="" src="{{ path('app_web_avatar', {'uid': app.user.id, 'name': app.user.avatar.smallName, 'ext': app.user.avatar.format}) }}">
                                        </div>
                                    </div>
                                    <br />
                                {% endif %}

                                <input class="hidden" type="file" id="avatar_file_select" accept=".gif,.jpg,.jpeg,.jif,.jfif,.png,.webp,.bmp">

                                {% if app.user.avatar is not null %}
                                    <label {% if app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionProfileAvatar')) %}disabled{% endif %} class="button" for="avatar_file_select">{{ 'Neues Profilbild hochladen'|trans({},'soul') }}</label>
                                    <button id="avatar_del">{{ 'Profilbild löschen'|trans({},'soul') }}</button>

                                    {% if not app.user.avatar.classic %}
                                        <button {% if app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionProfileAvatar')) %}disabled{% endif %} class="hide-sm hide-md" id="avatar_com" x-avatar-com-toggle>{{ 'Komprimierte Anzeige bearbeiten'|trans({},'soul') }}</button>
                                        <div class="row hide-lg hide-desktop">
                                            <div class="help">
                                                {% trans from 'soul' %}
                                                    Öffne MyHordes in einem größeren Fenster oder auf einem Gerät mit einem größeren Bildschirm, um den Bildausschnitt für die komprimierte Anzeige einzustellen.
                                                {% endtrans %}
                                            </div>
                                        </div>
                                        <div id="avatar_com_edit" class="row hidden hide-sm hide-md">
                                            <div class="padded cell rw-6 rw-lg-12">
                                                <div class="help">
                                                    {% trans from 'soul' %}
                                                        Wähle aus, welcher Teil deines Profilbilds für die komprimierte Darstellung verwendet werden soll. Bewege den Ausschnitt mit der Maus und vergrößere oder verkleinere ihn mit dem Mausrad.
                                                    {% endtrans %}
                                                </div>
                                            </div>
                                            <div class="padded cell rw-6 rw-lg-12 center">
                                                <div class="avatar no-arma full">
                                                    <div class="crop" id="crop_bar"><div id="crop-bar-inner"></div></div>
                                                    <img alt="" src="{{ path('app_web_avatar', {'uid': app.user.id, 'name': app.user.avatar.filename, 'ext': app.user.avatar.format}) }}">
                                                </div>
                                                <div class="right">
                                                    <button id="avatar_com_save" class="inline small">{{ 'Speichern'|trans({},'global') }}</button>
                                                    <button x-avatar-com-toggle class="inline small">{{ 'Abbrechen'|trans({},'global') }}</button>
                                                </div>
                                            </div>
                                        </div>

                                    {% endif %}
                                {% else %}
                                    <label {% if app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionProfileAvatar')) %}disabled{% endif %} class="button" for="avatar_file_select">{{ 'Profilbild hochladen'|trans({},'soul') }}</label>
                                {% endif %}
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div x-tab-target x-tab-group="user-settings-tabs" x-tab-id="security">
                    <h5>{{ 'Login und Sicherheit'|trans({},'soul') }}</h5>
                    <div class="row">
                        <div class="cell padded rw-4 rw-sm-12">
                            <div class="note note-lightest"><label for="app_mail">{% trans from 'soul' %}E-Mail-Adresse{% endtrans %}</label></div>
                        </div>
                        <div class="cell padded rw-8 rw-sm-12">
                            <input id="app_mail" type="text" disabled value="{{ app.user.email }}{% if app.user.pendingEmail is not null %} ({{ app.user.pendingEmail }}){% endif %}" />
                        </div>
                    </div>
                    {% if app.user.pendingEmail is null %}
                        <div class="row">
                            <div class="cell padded rw-4 rw-sm-12">
                                <div class="note note-lightest">{% trans from 'soul' %}E-Mail-Adresse ändern{% endtrans %}</div>
                            </div>

                            <div class="cell rw-8 rw-sm-12">
                                <div class="row">
                                    <div class="cell padded rw-6"><label><input id="app_email_change_new1" placeholder="{{ 'Neue E-Mail-Adresse'|trans({},'soul') }}" type="email" value="" /></label></div>
                                    <div class="cell padded rw-6"><label><input id="app_email_change_new2" placeholder="{{ 'E-Mail-Adresse wiederholen'|trans({},'soul') }}" type="email" value="" /></label></div>
                                    <div class="cell padded rw-12">
                                        <div class="note warning-box">
                                            {{ 'Du musst deine neue E-Mail Adresse validieren, bevor du sie verwenden kannst.'|trans({}, 'soul') }}
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% else %}
                        <div class="row">
                            <div class="cell padded rw-4 rw-sm-12">
                                <div class="note note-lightest">{% trans from 'soul' %}Validierungs-Token{% endtrans %}</div>
                            </div>
                            <div class="cell rw-8 rw-sm-12">
                                <div class="row">
                                    <div class="cell padded rw-12">
                                        <label><input id="email_validation_token" type="text" placeholder="abcdef123456" /></label>
                                    </div>
                                    <div class="cell padded rw-6">
                                        <button id="resend_token">{{ 'Validierung erneut senden'|trans({},'soul') }}</button>
                                    </div>
                                    <div class="cell padded rw-6">
                                        <button id="cancel_token">{{ 'Änderung der E-Mail Adresse abbrechen'|trans({},'soul') }}</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endif %}
                    {% if app.user.password is not null %}
                        <div class="row">
                            <div class="cell padded rw-4 rw-sm-12">
                                <div class="note note-lightest">{% trans from 'soul' %}Passwort ändern{% endtrans %}</div>
                            </div>
                            <div class="cell rw-8 rw-sm-12">
                                <div class="row">
                                    <div class="cell padded rw-6"><label><input id="app_pw_change_new1" placeholder="{{ 'Neues Passwort'|trans({},'soul') }}" type="password" value="" /></label></div>
                                    <div class="cell padded rw-6"><label><input id="app_pw_change_new2" placeholder="{{ 'Neues Passwort wiederholen'|trans({},'soul') }}" type="password" value="" /></label></div>
                                    <div class="cell padded rw-6"><label><input id="app_pw_change_old" placeholder="{{ 'Aktuelles Passwort'|trans({},'soul') }}" type="password" value="" /></label></div>
                                </div>
                            </div>
                        </div>
                    {% endif %}
                    {% if app.user.password is not null or app.user.pendingEmail is null %}
                        <div class="row">
                            <div class="padded cell rw-8 ro-4 rw-sm-12 ro-sm-0">
                                <button id="acc_ch_details">{{ 'Account-Infos aktualisieren'|trans({},'soul') }}</button>
                            </div>
                        </div>
                    {% endif %}
                    <br />
                    <div class="row">
                        <div class="cell padded rw-4 rw-sm-12">
                            <div class="note note-lightest">{% trans from 'soul' %}Überall ausloggen{% endtrans %}</div>
                        </div>
                        <div class="cell padded rw-8 rw-sm-12">
                            <button id="acc_unremember_me">{{ 'Auf allen Browsern & Geräten abmelden'|trans({},'soul') }}</button>
                            <p class="small">{% trans from 'soul' %}Hiermit kannst du dich von allen Geräten und Browsern abmelden, auf denen du aktuell eingeloggt bist. Die "Login merken" Funktion wird hierdurch ebenfalls auf den betroffenen Geräten deaktiviert.{% endtrans %}</p>
                            {% if is_granted('ROLE_ETERNAL') %}
                                <div class="note note-warning">{{ 'Denke daran, dich ebenfalls aus deinem EternalTwin Account auszuloggen!'|trans({},'soul') }}</div>
                            {% endif %}
                        </div>
                    </div>

                    {% if not is_granted('ROLE_ETERNAL') %}
                        <h5>{{ 'Account löschen'|trans({},'soul') }}</h5>
                        <div class="row">
                            <div class="padded cell rw-4">
                                <div class="note note-lightest"><label for="acc_del_input">{{ 'Aktuelles Passwort'|trans({},'login') }}</label></div>
                            </div>
                            <div class="padded cell rw-4"><input id="acc_del_input" type="password" /></div>
                            <div class="padded cell rw-4"><button id="acc_del_btn"><i class="fa fa-trash"></i> {{ 'Meinen Account löschen'|trans({},'soul') }}</button></div>
                        </div>
                    {% endif %}
                </div>

            {% if show_importer %}
                <div x-tab-target x-tab-group="user-settings-tabs" x-tab-id="soul-import">
                    <div class="row">
                        <div class="cell rw-6 ro-3 rw-md-8 ro-md-2 rw-sm-12 ro-sm-0">
                            {% if importer_readonly %}
                                <h5>{{ 'Importierte Seelen'|trans({},'soul') }}</h5>
                            {% else %}
                                <h5>{{ 'Seele importieren'|trans({},'soul') }}</h5>
                            {% endif %}
                            <div class="importSoulBanner">
                                <h4>{{ 'Willkommen bei MyHordes!'|trans({},'welcome') }}</h4>
                                <p>
                                    {{ 'Hast du ein Seele bei {hordes}, {dv}, {d2n} oder {zn}?'|trans({
                                        '{hordes}': '<i>Hordes</i>', '{dv}': '<i>Die Verdammten</i>', '{d2n}': '<i>Die2Nite</i>', '{zn}': '<i>Zombinoia</i>'
                                    },'soul')|raw }}
                                    {% if importer_readonly %}
                                        {{ '<b>Wenn du sie in der Vergangenheit importiert hast</b>, kannst du sie dir hier ansehen!'|trans({},'soul')|raw }}
                                    {% else %}
                                        <b>{{ 'Dann musst du nicht von Vorne beginnen!'|trans({},'soul') }}</b> {{ 'Importiere deine Seele und mache dort weiter, wo du aufgehört hast.'|trans({},'soul') }}
                                    {% endif %}
                                </p>
                                <button class="bigbutton" x-ajax-href="{{ url('soul_import') }}">
                                    <img class="float-left" alt="" src="{{ asset('build/images/icons/small_ghost_blue.gif') }}">
                                    {% if importer_readonly %}
                                        <span>{{ 'Importierte Seelen'|trans({},'soul') }}</span>
                                    {% else %}
                                        <span>{{ 'Seele importieren'|trans({},'soul') }}</span>
                                    {% endif %}
                                    <img class="right" alt="" src="{{ asset('build/images/icons/small_ghost_blue.gif') }}">
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            {% endif %}

            <div x-tab-target x-tab-group="user-settings-tabs" x-tab-id="general-settings">
                {% if app.user.language is defined %}
                    {% set preferredLanguage = app.user.language %}
                {% else %}
                    {% set preferredLanguage = 'de' %}
                {% endif %}

                {% if app.user.adminLang is defined and not app.user.adminLang is null %}
                    {% set preferredAdminLanguage = app.user.adminLang %}
                {% else %}
                    {% set preferredAdminLanguage = preferredLanguage %}
                {% endif %}

                <div class="row">
                    <div class="padded cell rw-12">
                        <h5>{{ 'Standardsprache'|trans({},'soul') }}</h5>
                        <div class="language-picker">
                            {% for lang in langs %}
                                <div class="note note-lightest">
                                    <input x-lang-setting {% if preferredLanguage == lang['code'] %}checked{% endif%} value="{{ lang['code'] }}" type="radio" name="setting_preferred_language" id="setting_preferred_language_{{ lang['code'] }}">&nbsp;<label for="setting_preferred_language_{{ lang['code'] }}">{{ lang['label']|trans({}, 'global') }}</label>
                                    {% if lang["tooltip"] != '' and lang['tooltip'] != null %}
                                        <div class="tooltip help">
                                            {{ lang['tooltip']|trans({}, 'global') }}
                                        </div>
                                    {% endif %}
                                </div>
                            {% endfor %}
                        </div>
                    </div>
                </div>
                {% if is_granted("ROLE_CROW") %}
                    <div class="row">
                        <div class="padded cell rw-12">
                            <h5>{{ 'Sprache der Admin-Oberfläche'|trans({},'soul') }}</h5>
                            <div class="language-picker">
                                {% for lang in langs %}
                                    <div class="note note-lightest">
                                        <input x-setting {% if preferredAdminLanguage == lang['code'] %}checked{% endif%} value="{{ lang['code'] }}" type="radio" name="admin_setting_preferred_language" id="admin_setting_preferred_language_{{ lang['code'] }}">&nbsp;<label for="admin_setting_preferred_language_{{ lang['code'] }}">{{ lang['label']|trans({}, 'global') }}</label>
                                        {% if lang["tooltip"] != '' and lang['tooltip'] != null %}
                                            <div class="tooltip help">
                                                {{ lang['tooltip']|trans({}, 'global') }}
                                            </div>
                                        {% endif %}
                                    </div>
                                {% endfor %}
                            </div>
                        </div>
                    </div>
                {% endif %}
                <div class="row">
                    <div class="cell rw-12">
                        <h5>{{ 'Benachrichtigungen'|trans({},'soul') }}</h5>
                        <div class="row">
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-setting {% if not app.user.noAutoFollowThreads %}checked{% endif%} type="checkbox" id="setting_auto_follow">&nbsp;<label for="setting_auto_follow">{{'Neuen Threads automatisch abonnieren'|trans({}, 'soul')}}</label>
                                    {{help_btn("Ist diese Option aktiviert, abonnierst du automatisch allen Threads, die du selbst erstellt hast. Du kannst das Abonnement deiner Threads jederzeit manuell beenden."|trans({}, 'soul'))}}
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-setting {% if app.user.setting( constant("\\App\\Enum\\UserSetting::NotifyMeOnFriendRequest") ) %}checked{% endif%} type="checkbox" id="setting_notify_on_friend">&nbsp;<label for="setting_notify_on_friend">{{'Benachrichrichtigung erhalten, wenn jemand mich als Freund hinzufügt'|trans({}, 'soul')}}</label>
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <label for="setting_notify_on_mention">{{'Benachrichrichtigung erhalten, wenn ich in einem Forenpost markiert werde'|trans({}, 'soul')}}</label>&nbsp;
                                    <select class="small" x-setting id="setting_notify_on_mention">
                                        <option value="0" {% if app.user.setting( constant("\\App\\Enum\\UserSetting::NotifyMeWhenMentioned") ) == 0 %}selected{% endif%}>{{ 'Deaktiviert'|trans({}, 'soul') }}</option>
                                        <option value="1" {% if app.user.setting( constant("\\App\\Enum\\UserSetting::NotifyMeWhenMentioned") ) == 1 %}selected{% endif%}>{{ 'Nur in Stadtforen'|trans({}, 'soul') }}</option>
                                        <option value="3" {% if app.user.setting( constant("\\App\\Enum\\UserSetting::NotifyMeWhenMentioned") ) == 3 %}selected{% endif%}>{{ 'Nur in Weltforen'|trans({}, 'soul') }}</option>
                                        <option value="2" {% if app.user.setting( constant("\\App\\Enum\\UserSetting::NotifyMeWhenMentioned") ) == 2 %}selected{% endif%}>{{ 'In allen Foren'|trans({}, 'soul') }}</option>
                                    </select>
                                    &nbsp;
                                    {{help_btn('Zum Schutz vor Spam wirst du unabhängig von dieser Einstellung keine Benachrichtigung erhalten, wenn in einem Post mehr als 5 Spieler (10 in Stadtforen) markiert sind.'|trans({}, 'soul'))}}
                                </div>
                            </div>
                        </div>

                        <h5>{{ 'Darstellung'|trans({},'soul') }}</h5>
                        <div class="row">
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-setting {% if app.user.preferSmallAvatars %}checked{% endif%} type="checkbox" id="setting_prefer_classic_avatars">&nbsp;<label for="setting_prefer_classic_avatars">{{ 'Bevorzugt komprimierte Profilbilder anzeigen'|trans({}, 'soul') }}</label>
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-setting {% if app.user.disableFx %}checked{% endif%} type="checkbox" id="setting_disable_fx">&nbsp;<label for="setting_disable_fx">{{ 'Animationen verringern'|trans({}, 'soul') }}</label> <a class="help-button"><div class="tooltip help">{{ 'Mache hier einen Haken, wenn die Landkarte nur sehr langsam geladen wird.<br /><em>Mit dieser Option senkst du die Qualität der Spielkartenanimationen.</em>.'|trans({},'soul')|raw }}</div>{{ 'Hilfe'|trans({},'global') }}</a>
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-setting {% if app.user.useICU %}checked{% endif%} type="checkbox" id="setting_use_icu">&nbsp;<label for="setting_use_icu">{{'Neue Übersetzungen verwenden'|trans({}, 'soul')}}</label>
                                    {{help_btn("Mit dem neuen Übersetzungssystem werden Texte akkurater in deiner Sprache dargestellt (zum Beispiel die passende Verwendung von Singular und Plural-Formen). Deaktiviere diese Option, um die originalen Texte aus Die Verdammten zu sehen."|trans({}, 'soul'))}}
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-setting {% if app.user.setting( constant("\\App\\Enum\\UserSetting::LimitTownListSize") ) %}checked{% endif%} type="checkbox" id="setting_limit_town_size">&nbsp;<label for="setting_limit_town_size">{{'Standartmäßig nur 10 Städte auf der Seelenseite anzeigen'|trans({}, 'soul')}}</label>
                                </div>
                            </div>
                        </div>

                        <h5>{{ 'Layout'|trans({},'soul') }}</h5>
                        <div class="row">
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-setting {% if app.user.classicBankSort %}checked{% endif%} type="checkbox" id="setting_classic_bank_sort">&nbsp;<label for="setting_classic_bank_sort">{{'Gegenstände in der Bank nach Anzahl sortieren'|trans({}, 'soul')}}</label>
                                    {{help_btn("Standartmäßig sortiert MyHordes Gegenstände in der Bank nach ihrem Typ. Aktiviere diese Option, wenn du die Sortierung von DieVerdammten bevorzugst, bei der Gegenstände primär nach ihrer Anzahl sortiert werden."|trans({}, 'soul'))}}
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-setting {% if app.user.setting( constant("\\App\\Enum\\UserSetting::ReorderTownLocationButtons") ) %}checked{% endif%} type="checkbox" id="setting_reorder-location-buttons-town">&nbsp;<label for="setting_reorder-location-buttons-town">{{'Orte in der Stadt platzsparend anordnen (mobil)'|trans({}, 'soul')}}</label>
                                    {{help_btn("Verwendet ein alternatives Layout für die verschiedenen Orte in der Stadt (Baustelle, dein Haus, etc) auf mobilen Geräten. Auf Desktops, Laptops oder Tablets mit größerem Display hat diese Einstellung keinen Effekt."|trans({}, 'soul'))}}
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-setting {% if app.user.setting( constant("\\App\\Enum\\UserSetting::ReorderActionButtonsBeyond") ) %}checked{% endif%} type="checkbox" id="setting_reorder-action-buttons-beyond">&nbsp;<label for="setting_reorder-action-buttons-beyond">{{'Aktionen in der Außenwelt platzsparend anordnen (mobil)'|trans({}, 'soul')}}</label>
                                    {{help_btn("Verwendet ein alternatives Layout für viele Aktionsschaltflächen in der Außenwelt auf mobilen Geräten. Auf Desktops, Laptops oder Tablets mit größerem Display hat diese Einstellung keinen Effekt. Dieses Layout spart Platz, zeigt aber für einige Schaltflächen nur noch ein Icon und keine Beschriftung mehr an. Diese Einstellung sollte daher nur von erfahrenen Spielern aktiviert werden."|trans({}, 'soul'))}}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div x-tab-target x-tab-group="user-settings-tabs" x-tab-id="browser-settings">
                <div class="row">
                    <div class="cell rw-12">
                        <h5>{{ 'Browser-Einstellungen'|trans({},'soul') }}</h5>
                        <div class="row">
                            <div class="padded cell rw-12">
                                <div class="help">
                                    {% trans from 'soul' %}
                                        Die folgenden Einstellungen werden in deinem Browser gespeichert und sind damit nur für dein aktuelles Gerät und deinen aktuellen Browser gültig.
                                    {% endtrans %}
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-browser-setting="notificationAsPopup" type="checkbox" id="setting_browser_notificationStyle">&nbsp;<label for="setting_browser_notificationStyle">{{ 'Benachrichtigungen als Popups anzeigen'|trans({}, 'soul') }}</label>
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-browser-setting="usePostBackup" type="checkbox" id="setting_browser_postBackup">&nbsp;<label for="setting_browser_postBackup">{{ 'Texteditor-Inhalte zur Sicherheit zwischenspeichern'|trans({}, 'soul') }}</label>
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-browser-setting="advancedPMEditor" type="checkbox" id="setting_browser_advancedPMEditor">&nbsp;<label for="setting_browser_advancedPMEditor">{{ 'Standartmäßig die erweiterte Editor-Ansicht für PNs verwenden'|trans({}, 'soul') }}</label>
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-browser-setting="autoParseLinks" type="checkbox" id="setting_browser_autoParseLinks">&nbsp;<label for="setting_browser_autoParseLinks">{{ 'Links in eigenen Posts automatisch klickbar machen'|trans({}, 'soul') }}</label>
                                </div>
                            </div>
                            <div class="padded cell rw-12">
                                <div class="note note-lightest">
                                    <input x-browser-setting="twoTapTooltips" type="checkbox" id="setting_browser_twoTapTooltips">&nbsp;<label for="setting_browser_twoTapTooltips">{{ 'Tooltips auf mobilen Geräten durch antippen anzeigen'|trans({}, 'soul') }}</label>
                                    {{help_btn("Ist diese Einstellung aktiviert, öffnet das erste Antippen eines Objekts dessen Tooltip - erst das zweite Antippen führt die eigentliche Aktion durch. Ist die Einstellung deaktiviert, führt das erste Antippen die Aktion direkt aus - um den Tooptip zu öffnen, muss das Objekt länger gedrückt werden. Dies bezieht sich ausschließlich auf Geräte mit Finger- oder Stifteingabe. Bei Mauseingaben hat diese Einstellung keinen Effekt."|trans({}, 'soul'))}}
                                </div>
                            </div>
                            <div class="padded cell rw-4 rw-md-6 rw-sm-12">
                                <div class="note note-lightest">
                                    <label for="setting_browser_iconZoom">{{ 'Icon-Zoom auf mobilen Geräten'|trans({}, 'soul') }}</label>
                                    {{help_btn("Um Items in deinem Rucksack und der Bank auf einem mobilen Gerät einfacher mit dem Finger auswählen zu können, kannst du deren Größe anpassen. Diese Einstellung betrifft nur mobile Geräte mit einem kleinen Bildschirm, beispielsweise Smartphones."|trans({}, 'soul'))}}
                                </div>
                            </div>
                            <div class="padded cell rw-8 rw-md-6 rw-sm-12">
                                <select id="setting_browser_iconZoom">
                                    <option value="1-00">x1 ({{ 'Zoom deaktiviert'|trans({}, 'soul') }})</option>
                                    <option value="1-25">x1.25</option>
                                    <option value="1-50">x1.5</option>
                                    <option value="1-75">x1.75</option>
                                    <option value="2-00">x2</option>
                                </select>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div x-tab-target x-tab-group="user-settings-tabs" x-tab-id="expert-settings">
                <h5>{{ 'Externe Anwendungen'|trans({},'soul') }}</h5>
                <div class="row">
                    <div class="cell padded rw-4 rw-sm-12">
                        <div class="note note-lightest"><label for="app_ext">{% trans from 'soul' %}Externe ID für Apps{% endtrans %}</label> <a class="help-button"><div class="tooltip help">{{ 'Diese ID übergibst du der Seite oder dem Programm, dem du einen (Lese-)Zugriff auf deine Spieldaten in "MyHordes" geben möchtest. Das sind Informationen zu deiner Stadt, dem Bürgerverzeichnis, der Weltkarte etc.'|trans({},'global') }}</div>{{ 'Hilfe'|trans({},'global') }}</a></div>
                    </div>
                    <div class="cell padded rw-4 rw-sm-12">
                        <input id="app_ext" type="text" readonly value="{% if app.user.externalId != '' %}{{ app.user.externalId }}{% else %}not set{% endif %}" />
                    </div>
                    <div class="cell padded rw-4 rw-sm-12">
                        <button id="generate-external-id">{{ 'Neue ID generieren'|trans({}, 'soul') }}</button>
                        <button id="delete-external-id">{{ 'ID löschen'|trans({}, 'soul') }}</button>
                        <p class="small">{% trans from 'soul' %}Mit dem Löschen der ID verhinderst Du den Zugriff externer Apps auf Deine Daten.{% endtrans %}</p>
                    </div>
                </div>
                {% if is_granted("ROLE_ADMIN") %}
                    <h5>{{ 'Standardrolle im Forum'|trans({},'soul') }}</h5>
                    <div class="row">
                        <div class="padded cell rw-12">
                            <div class="note note-lightest">
                                <input x-default-role-setting {% if app.user.postAsDefault == "DEV" %}checked{% endif%} type="checkbox" id="setting_default_forum_role">&nbsp;<label for="setting_default_forum_role">{{ 'Standardmäßig als dev posten'|trans({}, 'soul') }}</label>
                            </div>
                        </div>
                    </div>
                {% endif %}
                {% if is_granted("ROLE_CROW") %}
                    <h5>{{ 'Moderationseinstellungen'|trans({}, 'soul') }}</h5>
                    <div class="row">
                        <div class="padded cell rw-12">
                            <div class="note note-lightest">
                                <input x-open-mod-tools-window {% if app.user.openModToolsSameWindow %}checked{% endif%} type="checkbox" id="setting_open_same_window">&nbsp;<label for="setting_open_same_window">{{ 'Moderationslinks im selben Fenster öffnen'|trans({}, 'soul') }}</label>
                            </div>
                        </div>
                    </div>
                {% endif %}
            </div>
        </div>
    </div>
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>

        const confirmConig = function() {
            $.html.notice('{{ 'Deine Einstellung wurde gespeichert.'|trans({},'soul')|e('js') }}')
        }

        Array.from(document.querySelectorAll('input[x-browser-setting]')).forEach(function(e) {
            switch (e.getAttribute('type')) {
                case 'checkbox':
                    e.checked = $.client.config.get(e.getAttribute('x-browser-setting')).get();
                    e.addEventListener('change', function() {
                        $.client.config.get(e.getAttribute('x-browser-setting')).set(e.checked);
                        confirmConig();
                    } );
                    break;
                default: return;
            }
        })

        $.html.forEach('#setting_browser_iconZoom', e => e.value = $.client.config.iconZoom.get());
        $.html.addEventListenerAll('#setting_browser_iconZoom', 'change', function(e,elem) {
            const old_classes = document.body.classList;
            old_classes.forEach(c => {
                if (c.substring(0,10) === 'icon-zoom-') document.body.classList.remove(c);
            });

            document.body.classList.add('icon-zoom-' + elem.value);
            $.client.config.iconZoom.set(elem.value);
            confirmConig();
        });

        $.html.addEventListenerAll('#acc_del_btn', 'click', function(e) {
            e.preventDefault();
            const pw = document.getElementById('acc_del_input').value;
            if (!confirm('{{ 'Bist du sicher, dass du deinen Account jetzt löschen möchtest? Dieser Vorgang kann nicht rückgängig gemacht werden!'|trans({},'soul')|e('js') }}'))
                return;

            $.ajax.easySend( '{{ path('api_soul_delete_account') }}', {'pw': pw},
                function () {
                    alert(
                        '{{ 'Auf wiedersehen, {name}. Wir werden dich vermissen und hoffen, dass du vielleicht doch noch einmal zurück kommst.'|trans( {'name': app.user.name}, 'login')|e('js') }}' + "\n\n" +
                        '{{ 'Du wirst nun ausgeloggt. Dein Account wird in 24-48 Stunden gelöscht. Bis dahin kannst du dich jederzeit erneut einloggen und dadurch die Löschung deines Accounts abbrechen.'|trans({},'soul')|e('js') }}'
                    );
                    window.location.href = $.ajax.getBaseURL();
                } )
        });

        $.html.addEventListenerAll('#acc_ch_details', 'click', function(e) {
            e.preventDefault();
            let pw_old  = document.getElementById('app_pw_change_old')?.value ?? '';
            let pw_new1 = document.getElementById('app_pw_change_new1')?.value ?? '';
            let pw_new2 = document.getElementById('app_pw_change_new2')?.value ?? '';
            let email_new1 = document.getElementById('app_email_change_new1')?.value ?? '';
            let email_new2 = document.getElementById('app_email_change_new2')?.value ?? '';

            let email_token = '';
            {% if app.user.pendingEmail is not null %}
                email_token = document.getElementById('email_validation_token').value;
            {% endif %}

            if (pw_new1 !== '' && pw_new1 !== pw_new2) {
                $.html.error('{{ 'Die eingegebenen Passwörter stimmen nicht überein.'|trans({},'login')|e('js') }}');
                return;
            }

            if (pw_new1 !== '' && pw_new1.length < 6) {
                $.html.error('{{ 'Dein Passwort muss mindestens { limit } Zeichen umfassen.'|trans({'{{ limit }}': 6},'login')|e('js') }}');
                return;
            }

            if (email_new1 !== '' && email_new1 !== email_new2) {
                $.html.error('{{ 'Die eingegebenen E-Mail Adressen stimmen nicht überein.'|trans({},'login')|e('js') }}');
                return;
            }

            if (email_new1 !== '' && !$.html.validateEmail(email_new1)) {
                $.html.error('{{ 'Die eingegebene E-Mail Adresse ist nicht korrekt.'|trans({},'login')|e('js') }}');
                return;
            }

            $.ajax.easySend( '{{ path('api_soul_change_account_details') }}', {'pw': pw_old, 'pw_new': pw_new1, 'email_new': email_new1, 'email_token': email_token},
                function () {
                    $.ajax.load(null, pw_new1 !== '' ? '{{ path('public_login') }}' : '{{ path('soul_settings') }}', true);
                } )
        });
        {% if app.user.pendingEmail is not null %}
        $.html.addEventListenerAll('#resend_token', 'click', function(e) {
            e.preventDefault();

            $.ajax.easySend( '{{ path('api_soul_resend_token_email') }}', {},
                function () {
                    $.ajax.load(null, '{{ path('soul_settings') }}', true);
                } )
        });

        $.html.addEventListenerAll('#cancel_token', 'click', function(e) {
            e.preventDefault();

            $.ajax.easySend( '{{ path('api_soul_cancel_email_token') }}', {},
                function () {
                    $.ajax.load(null, '{{ path('soul_settings') }}', true);
                } )
        });
        {% endif %}

        $.html.addEventListenerAll('#acc_unremember_me', 'click', function(e) {
            $.ajax.easySend( '{{ path('api_soul_unremember_me') }}', {},
                function () {
                    window.location.reload()
                } )
        });

        $.html.addEventListenerAll('#generate-external-id', 'click', function(e) {
            e.preventDefault();
            $.ajax.easySend( '{{ path('api_soul_settings_generateid') }}', [],
                function () {
                    $.ajax.load(null, '{{ path('soul_settings') }}', true);
                } )
        });
        $.html.addEventListenerAll('#delete-external-id', 'click', function(e) {
            e.preventDefault();
            $.ajax.easySend( '{{ path('api_soul_settings_deleteid') }}', [],
                function () {
                    $.ajax.load(null, '{{ path('soul_settings') }}', true);
                } )
        });

        let del_btn = document.getElementById('avatar_del')
        if (del_btn) del_btn.addEventListener('click', function() {
            if (confirm('{{ 'Bestätigen?'|trans({},'global')|e('js') }}'))
                $.ajax.easySend( '{{ path('api_soul_avatar') }}', {up: 0},
                    function () {
                        $.ajax.load(null, '{{ path('soul_settings') }}', true);
                    } )
        });
        $.html.addEventListenerAll('[x-setting]', 'change', function(e,elem) {
            $.ajax.easySend( '{{ path('api_soul_common') }}', {
                    sma: document.getElementById('setting_prefer_classic_avatars').checked,
                    disablefx: document.getElementById('setting_disable_fx').checked,
                    useicu: document.getElementById('setting_use_icu').checked,
                    autofollow: document.getElementById('setting_auto_follow').checked,
                    clasort: document.getElementById('setting_classic_bank_sort').checked,
                    town10: document.getElementById('setting_limit_town_size').checked,
                    notify: document.getElementById('setting_notify_on_mention').value,
                    notifyFriend: document.getElementById('setting_notify_on_friend').checked,
                    beyondAltLayout: document.getElementById('setting_reorder-action-buttons-beyond').checked,
                    townAltLayout: document.getElementById('setting_reorder-location-buttons-town').checked,
                    {% if is_granted("ROLE_CROW") %}
                    adminLang: document.querySelector("input[name=admin_setting_preferred_language]:checked").value
                    {% endif %}
                },
                function () {
                    $.ajax.load(null, '{{ path('soul_settings') }}', true);
                } )
        });
        $.html.addEventListenerAll('[x-lang-setting]', 'change', function(e,elem) {
            $.ajax.easySend( '{{ path('api_soul_set_language') }}', {
                lang: document.querySelector("input[name=setting_preferred_language]:checked").value
                },
                function () {
                    window.location.href = '{{ url('soul_settings') }}';
                } )
        });

        {% if is_granted("ROLE_ADMIN") %}
        $.html.addEventListenerAll('[x-default-role-setting]', 'change', function(e,elem) {
            $.ajax.easySend( '{{ path('api_soul_defaultrole') }}', {
                    dev: document.getElementById('setting_default_forum_role').checked
                },
                function () {
                    $.ajax.load(null, '{{ path('soul_settings') }}', true);
                } )
        });
        {% endif %}

        {% if is_granted("ROLE_CROW") %}
        $.html.addEventListenerAll('[x-open-mod-tools-window]', 'change', function(e,elem) {
            $.ajax.easySend( '{{ path('api_soul_mod_tools_window') }}', {
                    same_window: document.getElementById('setting_open_same_window').checked
                },
                function () {
                    $.ajax.load(null, '{{ path('soul_settings') }}', true);
                } )
        });
        {% endif %}

        document.getElementById('avatar_file_select').addEventListener('change', function(e) {
            if (e.target.files.length !== 1) {
                $.html.error('{{ 'Bitte wähle nur eine einzige Datei aus.'|trans({},'soul')|e('js') }}');
                return;
            }
            /** @var file File */
            const file = e.target.files[0];
            if (file.size >= {{ avatar_max_size[2] }}) {
                $.html.error('{{ 'Die Datei ist zu groß.'|trans({},'soul')|e('js') }}');
                return;
            }

            const type_info = file.type.split('/',2);
            if (type_info.length < 2 || type_info[0] !== 'image') {
                $.html.error('{{ 'Dieses Dateiformat wird nicht unterstützt.'|trans({},'soul')|e('js') }}');
                return;
            }

            let reader = new FileReader();
            reader.onload = function(e) {
                $.ajax.easySend( '{{ path('api_soul_avatar') }}', {up: 1, mime: type_info[1], image: btoa(e.target.result)},
                    function () {
                        $.ajax.load(null, '{{ path('soul_settings') }}', true);
                    } )
            };
            reader.readAsBinaryString(file);
        });

        {% if app.user.avatar and not app.user.avatar.classic %}
            $.html.addEventListenerAll('[x-avatar-com-toggle]', 'click', function(e,elem) {
                let controls = document.getElementById('avatar_com_edit');
                let button   = document.getElementById('avatar_com');
                if (controls.classList.contains('hidden')) {
                    controls.classList.remove('hidden')
                    button.classList.add('hidden')
                } else {
                    controls.classList.add('hidden')
                    button.classList.remove('hidden')
                }
            });

            let sc_px = 0, sc_py = 0;
            let sc_dx = Math.min({{ app.user.avatar.x }}, {{ app.user.avatar.y*3 }}), sc_dy = Math.min({{ app.user.avatar.x/3 }}, {{ app.user.avatar.y }});

            $.html.addEventListenerAll('#avatar_com_save', 'click', function(e) {
                e.preventDefault();
                $.ajax.easySend( '{{ path('api_soul_small_avatar') }}', {x: sc_px, y: sc_py, dx: sc_dx, dy: sc_dy},
                    function () {
                        $.ajax.load(null, '{{ path('soul_settings') }}', true);
                    } )
            });

            let dc = document.getElementById('crop_bar');
            if (dc) {
                dc.style.width = sc_dx + 'px';
                dc.style.height  = sc_dy + 'px';
            }

            $.html.addEventListenerAll('#crop_bar', 'wheel', function(e,elem) {
                e.preventDefault();
                e.stopPropagation();
                const d = e.deltaY / Math.abs(e.deltaY);

                sc_dx = Math.max(45, Math.min(sc_dx - d*2, elem.parentElement.clientWidth ));
                sc_dy = sc_dx / 3;
                elem.style.width = sc_dx + 'px';
                elem.style.height  = sc_dy + 'px';

                sc_px = Math.max(0, Math.min(sc_px + d, elem.parentElement.clientWidth - elem.clientWidth ));
                sc_py = Math.max(0, Math.min(sc_py + d/3, elem.parentElement.clientHeight - elem.clientHeight))

                elem.style.left = sc_px + 'px';
                elem.style.top  = sc_py + 'px';
            });

            $.html.addEventListenerAll('#crop_bar', 'mousemove', function(e,elem) {

                if (e.buttons & 1) {
                    e.preventDefault();
                    e.stopPropagation();

                    sc_dx = Math.max(45, Math.min(sc_dx + e.movementX/2, elem.parentElement.clientWidth ))
                    sc_dy = sc_dx / 3;
                    elem.style.width = sc_dx + 'px';
                    elem.style.height  = sc_dy + 'px';

                    sc_px = Math.max(0, Math.min(sc_px - e.movementX/2, elem.parentElement.clientWidth - elem.clientWidth ))
                    sc_py = Math.max(0, Math.min(sc_py - e.movementY/2, elem.parentElement.clientHeight - elem.clientHeight))
                    elem.style.left = sc_px + 'px';
                    elem.style.top  = sc_py + 'px';
                }
            } )

            $.html.addEventListenerAll('#crop_bar>div', 'mousemove', function(e,elem) {

                let cb = elem.parentElement;
                if (e.buttons & 1) {
                    e.preventDefault();
                    e.stopPropagation();

                    sc_px = Math.max(0, Math.min(sc_px + e.movementX, cb.parentElement.clientWidth - cb.clientWidth ))
                    sc_py = Math.max(0, Math.min(sc_py + e.movementY, cb.parentElement.clientHeight - cb.clientHeight))

                    cb.style.left = sc_px + 'px';
                    cb.style.top  = sc_py + 'px';
                }
            } )
        {% endif %}

        $.html.addEventListenerAll('#user_displayname', 'input', () => $.html.forEach('#name-warning-box', e => e.classList.remove('hidden')))

        $.html.addEventListenerAll('#save_profile_header', 'click', () => {
            const title = parseInt(document.getElementById('user_title').value);
            const icon  = parseInt(document.getElementById('user_icon').value);
            const flag  = document.getElementById('user_flag').value;
            const pronounSel = document.querySelector('input[name="user_pronoun"]:checked');
            const pronoun = pronounSel ? pronounSel.value : 'none';

            if (icon >= 0 && title < 0) {
                $.html.error('{{ 'Du kannst kein Icon ohne einen Titel wählen.'|trans({},'soul')|e('js') }}');
                return;
            }

            $.ajax.easySend('{{ path('api_soul_header')|e('js') }}', {
                title, icon, flag, pronoun,
                desc: $.html.twinoParser.parseToString(document.getElementById('user_desc').value, s => [null,s], {autoLinks: $.client.config.autoParseLinks.get()}),
                displayName: document.getElementById('user_displayname').value
            }, () => {
                $.html.notice('{{ 'Deine Einstellung wurde gespeichert.'|trans({},'soul')|e('js') }}');
                $.ajax.load(null, '{{ path('soul_settings')|e('js') }}');
            });
        });

        $.html.addEventListenerAll('#show_icon_sel', 'click', (e,elem) => {
            elem.style.display = 'none';
            document.getElementById('icon_sel').style.display = null;
        });
        $.html.addEventListenerAll('#hide_icon_sel', 'click', () => {
            document.getElementById('show_icon_sel').style.display = null;
            document.getElementById('icon_sel').style.display = 'none';
        });
        $.html.addEventListenerAll('[x-title-icon]', 'click', (e,elem) => {
            const id = parseInt(elem.getAttribute('x-title-icon'));
            let target = document.getElementById('user_current_icon');
            if (id < 0) {
                target.setAttribute('src','');
                target.style.display = 'none';
            } else {
                target.setAttribute('src',elem.getAttribute('src'));
                target.style.display = null;
            }
            document.getElementById('user_icon').value = id;
            document.getElementById('show_icon_sel').style.display = null;
            document.getElementById('icon_sel').style.display = 'none';
        });

        $.html.addEventListenerAll('#show_flag_sel', 'click', (e,elem) => {
            elem.style.display = 'none';
            document.getElementById('flag_sel').style.display = null;
        });
        $.html.addEventListenerAll('#hide_flag_sel', 'click', () => {
            document.getElementById('show_flag_sel').style.display = null;
            document.getElementById('flag_sel').style.display = 'none';
        });
        $.html.addEventListenerAll('[data-flag]', 'click', (e,elem) => {
            const id = elem.dataset.flag;
            let target = document.getElementById('user_current_flag');
            if (id === '') {
                target.firstElementChild.setAttribute('src','');
                target.firstElementChild.setAttribute('alt','');
                target.classList.add('hidden');
            } else {
                target.firstElementChild.setAttribute('src',elem.firstElementChild.getAttribute('src'));
                target.firstElementChild.setAttribute('alt',id);
                target.classList.remove('hidden');
            }
            document.getElementById('user_flag').value = id;
            document.getElementById('show_flag_sel').style.display = null;
            document.getElementById('flag_sel').style.display = 'none';
        });

        document.getElementById('user_desc').value = $.html.twinoParser.parseFrom('{{ user_desc|e('js') }}', $.html.twinoParser.OpModeRaw);
    </script>
{% endblock %}